inputfile$ = ProgramParameter(0)

If inputfile$ = "" 
 MessageRequester("DPG Demuxer v1.004","Usage: " + Chr(10) + "          demux.exe <input file> [output directory - optional]" + Chr(10) + Chr(10) + "Ensure to wrap file paths in quotation marks and use trailing backslashes." + Chr(10) + Chr(10) + Chr(10) + "Ver 1.004, 21/01/2007 by slydramon")
 End
EndIf

If ReadFile(0, inputfile$)

  filename$ = StringField(inputfile$, CountString(inputfile$,"\")+1, "\")
  outputdir$ = ProgramParameter(1)
  If outputdir$ = ""
    outputdir$  = Left(inputfile$,Len(inputfile$) - Len(filename$))
  EndIf
  dpgname$ = Left(filename$,Len(filename$)-4)
  
  ;; RECURSIVELY CHECK / CREATE OUTPUT PATH DIRECTORY ;;
  
  dirLen = 0
  
  For i = 1 To CountString(outputdir$,"\")
   dirLen = dirLen + Len(StringField(outputdir$,i,"\")) + 1
   CreateDirectory(Left(outputdir$,dirLen))  
  Next
  
  If FileSize(outputdir$) <> -2
    MessageRequester("Error","Output directory is invalid!")
    End
  EndIf

  #buffersize = 4096
  
  dpgtype$ = Chr(ReadCharacter(0)) + Chr(ReadCharacter(0)) + Chr(ReadCharacter(0)) + Chr(ReadCharacter(0)) 
  
  If dpgtype$ <> "DPG0" And dpgtype$ <> "DPG1" And dpgtype$ <> "DPG2"
   MessageRequester("Error","Unknown input file format! (" + dpgtype$ + ")")
   End
  EndIf
  
  frames = ReadLong(0)
  
  ReadByte(0)
  
  fps = ReadCharacter(0)
  
  ReadByte(0)
  ReadByte(0)
  
  samplerate = ReadLong(0)

  ReadLong(0)
  
  audiostart = ReadLong(0)
  audiosize = ReadLong(0)
  
  videostart = ReadLong(0)
  videosize = ReadLong(0)
  
  If dpgtype$ = "DPG1"
   
   pixelformat = ReadLong(0)
   
  EndIf
  
  If dpgtype$ = "DPG2"
  
   gopstart = ReadLong(0)
   gopsize = ReadLong(0)
   pixelformat = ReadLong(0)
   
  EndIf
  
  If dpgtype$ = "DPG0"
   
   pixelformat = $00030000
   
  EndIf
  
  
  *FileBuff = AllocateMemory(#buffersize)
  
  If Not *FileBuff 
    MessageRequester("Error","Cannot allocate " + Str(#buffersize) + " bytes!")
    End
  EndIf
  
  ; START FPS FILE ;
  
  DeleteFile(outputdir$ + "\" + dpgname$ + ".fps")
  If OpenFile(1,outputdir$ + "\" + dpgname$ + ".fps")
    WriteCharacter(1,fps)
    WriteLong(1,samplerate)
    WriteLong(1,pixelformat)
    WriteString(1,StrU(frames,2))
    CloseFile(1)
  Else
    MessageRequester("Error","Cannot create output FPS file!")
  EndIf
  
  ; START AUDIO ;
  
  DeleteFile(outputdir$ + "\" + dpgname$ + ".mp2")
  If OpenFile(1,outputdir$ + "\" + dpgname$ + ".mp2")
    For bufpos = 0 To audiosize Step #buffersize
      nbytes = bufpos + #buffersize
      If nbytes > audiosize
        nbytes = audiosize
      EndIf
      ReadData(0,*FileBuff,nbytes-bufpos)
      WriteData(1,*FileBuff,nbytes-bufpos)
    Next
    CloseFile(1)
  Else
    MessageRequester("Error","Cannot create output audio file!")
  EndIf
  
  ; START VIDEO ;
  
  DeleteFile(outputdir$ + "\" + dpgname$ + ".m1v")
  If OpenFile(1,outputdir$ + "\" + dpgname$ + ".m1v")
    For bufpos = 0 To videosize Step #buffersize
      nbytes = bufpos + #buffersize
      If nbytes > videosize
        nbytes = videosize
      EndIf
      ReadData(0,*FileBuff,nbytes-bufpos)
      WriteData(1,*FileBuff,nbytes-bufpos)
    Next
    CloseFile(1)
  Else
    MessageRequester("Error","Cannot create output video file!")
  EndIf
  
  ; START GOP ; 
  
  If dpgtype$ = "DPG2"
    DeleteFile(outputdir$ + "\" + dpgname$ + ".gop")
    If OpenFile(1,outputdir$ + "\" + dpgname$ + ".gop")
      For bufpos = 0 To gopsize Step #buffersize
        nbytes = bufpos + #buffersize
        If nbytes > gopsize
          nbytes = gopsize
        EndIf
        ReadData(0,*FileBuff,nbytes-bufpos)
        WriteData(1,*FileBuff,nbytes-bufpos)
      Next
      CloseFile(1)
    Else
      MessageRequester("Error","Cannot create output GOP file!")
    EndIf
  EndIf
  
  
  ; ALL DONE ;
  CloseFile(0)
  
Else
  MessageRequester("Error","Cannot open input file!")
EndIf